<?php
/*********************************************************************************
 * SugarCRM is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004 - 2008 SugarCRM Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 ********************************************************************************/

require_once('modules/inv_InvoiceLines/inv_InvoiceLines_sugar.php');

/**
 * The InvoiceLines bean class
 */
class inv_InvoiceLines extends inv_InvoiceLines_sugar
{
	/**
	 * Constructor
	 */
	function inv_InvoiceLines()
	{	
		parent::inv_InvoiceLines_sugar();
	}

	/**
	 * Override fill_in_link_field to support a bean_filter attribute on link variables.
	 * This can be used to implement grandparent fields
	 */
	function fill_in_link_field($field)
	{
		if ($this->load_relationship($field))
		{
			$bean_filter = '';
			$bean_filter_field = $this->field_defs[$field]['bean_filter'];
			if ($bean_filter_field)
			{
				// If the bean_filter is another link, make sure it's loaded
				if (empty($this->$bean_filter_field) && $this->field_defs[$bean_filter_field]['type'] == 'link')
					$this->fill_in_link_field($bean_filter_field);

				// If the bean_filter link cannot be loaded or is empty then this linked field is empty as well
				if (empty($this->$bean_filter_field)) {
					$this->$field = '';
					return;
				}

				$bean_filter = "= '" . $this->$bean_filter_field . "'";
			}

			$query = $this->$field->getQuery(false, array(), 0, '', false, $bean_filter);
			$result = $this->$field->_db->query($query, true);
			$row = $this->$field->_db->fetchByAssoc($result);
			$this->$field = '' ; // match up with null value in $this->populateFromRow()
			
			if (!empty($row))
				$this->$field = $row['id'];
		}
	}
	
	/**
	 * Do not save the grandparent fields
	 */
	function save_relationship_changes($is_update, $exclude = array())
	{
		$exclude = array_merge($exclude, array('account_id'));
		parent::save_relationship_changes($is_update, $exclude);
	}
}

?>
